# Changelog

All notable changes to this project will be documented in this file. See [standard-version](https://github.com/conventional-changelog/standard-version) for commit guidelines.

## [5.3.0](https://github.com/GluuFederation/gluu-passport/compare/v5.2.0...v5.3.0) (2021-09-03)


### Features

* **httpProxy:** add support to global http proxy ([#333](https://github.com/GluuFederation/gluu-passport/issues/333)) ([121a629](https://github.com/GluuFederation/gluu-passport/commit/121a629189e36d7b500ea10d82459d6906cda030))


### Bug Fixes

* **package-lock.json:** update node-xtraverse due to vulnerability in xmldom ([#327](https://github.com/GluuFederation/gluu-passport/issues/327)) ([903ebb4](https://github.com/GluuFederation/gluu-passport/commit/903ebb4b9e5900496c883d5e5e1f72fb39992a32))
* remove decimal points from Client assertion JWT exp time ([#315](https://github.com/GluuFederation/gluu-passport/issues/315)) ([6ba5b9b](https://github.com/GluuFederation/gluu-passport/commit/6ba5b9bc687e1cdd7cc17fb22053e659f961282b)), closes [#313](https://github.com/GluuFederation/gluu-passport/issues/313) [#313](https://github.com/GluuFederation/gluu-passport/issues/313) [#313](https://github.com/GluuFederation/gluu-passport/issues/313)

### [5.2.1](https://github.com/GluuFederation/gluu-passport/compare/v5.2.0...v5.2.1) (2021-07-30)


### Bug Fixes

* remove decimal points from Client assertion JWT exp time ([#315](https://github.com/GluuFederation/gluu-passport/issues/315)) ([6ba5b9b](https://github.com/GluuFederation/gluu-passport/commit/6ba5b9bc687e1cdd7cc17fb22053e659f961282b)), closes [#313](https://github.com/GluuFederation/gluu-passport/issues/313) [#313](https://github.com/GluuFederation/gluu-passport/issues/313) [#313](https://github.com/GluuFederation/gluu-passport/issues/313)

## [5.2.0](https://github.com/GluuFederation/gluu-passport/compare/v5.1.0...v5.2.0) (2021-07-15)


### Features

* **openid-client-helper.js:** init issuer with and without discovery endpoint ([c287f10](https://github.com/GluuFederation/gluu-passport/commit/c287f10da56ab7e1788bf79e5d4b5735a2ff9c0b)), closes [#241](https://github.com/GluuFederation/gluu-passport/issues/241)


### Bug Fixes

* **logging.test.js:** fix empty dirname and use existing log dir path ([003cf15](https://github.com/GluuFederation/gluu-passport/commit/003cf15d9b222755268dd0ff3a23e7f9933a82af)), closes [#297](https://github.com/GluuFederation/gluu-passport/issues/297)

## [5.1.0](https://github.com/GluuFederation/gluu-passport/compare/v5.0.0...v5.1.0) (2021-07-13)


### Features

* **routes.js:** track error logs generated by passport strategies ([9820226](https://github.com/GluuFederation/gluu-passport/commit/98202261329c8b4137173777b918ed7416ce5de2)), closes [#250](https://github.com/GluuFederation/gluu-passport/issues/250)


### Bug Fixes

* **dependencies:** relock file to fix vulnerability ([d5c298f](https://github.com/GluuFederation/gluu-passport/commit/d5c298f32890689cf073390a17c1205d134cc59c))
* **package.json:** fix twitter volunerability ([1812efd](https://github.com/GluuFederation/gluu-passport/commit/1812efd99f0e0fe6f297cc1ddf5d054d825801d3)), closes [#265](https://github.com/GluuFederation/gluu-passport/issues/265)
* **package.json:** fix url issue ([93dde9a](https://github.com/GluuFederation/gluu-passport/commit/93dde9a640847115161a433a3f8ff95d695d576d))
* **security:** update vulnerable dep tree ([59b725a](https://github.com/GluuFederation/gluu-passport/commit/59b725abf756d8e959a0c454ece26db78de97124))

## [5.0.0](https://github.com/GluuFederation/gluu-passport/compare/v4.4.0...v5.0.0) (2021-06-03)


### ⚠ BREAKING CHANGES

* **openid-connect:** All openid providers needs to be reconfigured according to new specs. Changes
required at oxTrust.
* **security:** We need to update from ox trust breakingchnage descriptiotn

### Features

* **app-factory:** ensure session is handlable externaly ([e7106e6](https://github.com/GluuFederation/gluu-passport/commit/e7106e6545b422a149b457c96110a9ecc10ad1e6))
* **config:** ensure sameSite exists and value is lax in default ([aeff791](https://github.com/GluuFederation/gluu-passport/commit/aeff791b6d68add2e33da13d204592c28f903cc5))
* **config:** ensure sameSite exists in production ([3ee1504](https://github.com/GluuFederation/gluu-passport/commit/3ee1504c2fd4aa1079ea5de99440d0576e8e38e9))
* **config:** ensure secure exists in production ([e3d41c3](https://github.com/GluuFederation/gluu-passport/commit/e3d41c37d0e6ae4da26e5aab303c2a2b6040b647))
* **config:** ensure secure is true in production ([5747cba](https://github.com/GluuFederation/gluu-passport/commit/5747cbaf9497d99363cda519705e82b5281d67dd))
* **config:** ensure secure value is false in default ([9709ab9](https://github.com/GluuFederation/gluu-passport/commit/9709ab9a7c398bea4ae6e8ce21aa04cbc3a65121))
* **file-utils.js file-utils.test.js:** made a seperate utils for common file operations ([fbdf323](https://github.com/GluuFederation/gluu-passport/commit/fbdf32319527c91b5dc7c280a22b3cac50855a1d)), closes [#206](https://github.com/GluuFederation/gluu-passport/issues/206)
* **openid-client-helper.js:** Added utility for openid client strategy initialization ([da25ac3](https://github.com/GluuFederation/gluu-passport/commit/da25ac39040bb10e0f8f9ac73f42205cdb4da277)), closes [#206](https://github.com/GluuFederation/gluu-passport/issues/206)
* **openid-connect:** replace deprecated openid lib with openid-client ([e0e165f](https://github.com/GluuFederation/gluu-passport/commit/e0e165fbafdd9ad7074051af5b84d373c00c8756)), closes [#204](https://github.com/GluuFederation/gluu-passport/issues/204)
* **package.json:** support node 14.16.0 to 15.11.0 ([da7fd3b](https://github.com/GluuFederation/gluu-passport/commit/da7fd3be36c65ff01d675fb9e0d37e3971c54589)), closes [#213](https://github.com/GluuFederation/gluu-passport/issues/213)
* **providers.js:** added openid-client strategy support ([514aad8](https://github.com/GluuFederation/gluu-passport/commit/514aad8dac91b74ce29b9b23051b91b4542d0e22)), closes [#206](https://github.com/GluuFederation/gluu-passport/issues/206)
* **session.js session.test.js:** make separate file for session config ([5092baf](https://github.com/GluuFederation/gluu-passport/commit/5092bafe75a6240f095c1aff5d84f4521383a084)), closes [#242](https://github.com/GluuFederation/gluu-passport/issues/242)


### Bug Fixes

* **config.test.js:** update cookie config keys title ([72646a5](https://github.com/GluuFederation/gluu-passport/commit/72646a5600a68e3229f6faba60f126e776f6b597)), closes [#242](https://github.com/GluuFederation/gluu-passport/issues/242)
* **security:** reokacc openid connect dep ([224fbdd](https://github.com/GluuFederation/gluu-passport/commit/224fbdd44a50caab49d17cf0801b506bcfac4e70))
* **session:** ensure cookies settings are correct ([7c24b83](https://github.com/GluuFederation/gluu-passport/commit/7c24b835c0580aa3a09c16486edb9045d88eca36))
* package.json & package-lock.json to reduce vulnerabilities ([218b7ce](https://github.com/GluuFederation/gluu-passport/commit/218b7cef7f8b2cf465d0b059246fabc3da4458e4))

## [4.5.0](https://github.com/GluuFederation/gluu-passport/compare/v4.4.0...v4.5.0) (2021-03-30)


### Features

* **config:** ensure sameSite exists and value is lax in default ([aeff791](https://github.com/GluuFederation/gluu-passport/commit/aeff791b6d68add2e33da13d204592c28f903cc5))
* **config:** ensure sameSite exists in production ([3ee1504](https://github.com/GluuFederation/gluu-passport/commit/3ee1504c2fd4aa1079ea5de99440d0576e8e38e9))
* **config:** ensure secure exists in production ([e3d41c3](https://github.com/GluuFederation/gluu-passport/commit/e3d41c37d0e6ae4da26e5aab303c2a2b6040b647))
* **config:** ensure secure is true in production ([5747cba](https://github.com/GluuFederation/gluu-passport/commit/5747cbaf9497d99363cda519705e82b5281d67dd))
* **config:** ensure secure value is false in default ([9709ab9](https://github.com/GluuFederation/gluu-passport/commit/9709ab9a7c398bea4ae6e8ce21aa04cbc3a65121))
* **session** make separate file for session config ([5092baf](https://github.com/GluuFederation/gluu-passport/commit/5092bafe75a6240f095c1aff5d84f4521383a084)), closes [#242](https://github.com/GluuFederation/gluu-passport/issues/242)


### Bug Fixes

* **config.test.js:** update cookie config keys title ([72646a5](https://github.com/GluuFederation/gluu-passport/commit/72646a5600a68e3229f6faba60f126e776f6b597)), closes [#242](https://github.com/GluuFederation/gluu-passport/issues/242)
* **session:** ensure cookies settings are correct ([7c24b83](https://github.com/GluuFederation/gluu-passport/commit/7c24b835c0580aa3a09c16486edb9045d88eca36))
* package.json & package-lock.json to reduce vulnerabilities ([218b7ce](https://github.com/GluuFederation/gluu-passport/commit/218b7cef7f8b2cf465d0b059246fabc3da4458e4))

## [4.4.0](https://github.com/GluuFederation/gluu-passport/compare/v4.3.6...v4.4.0) (2021-02-22)


### Features

* **app-factory.js:** added rate-limiting facility ([51b6ba3](https://github.com/GluuFederation/gluu-passport/commit/51b6ba3c5da71a955ecef232d4e6c2cfa8c3c2e5)), closes [#139](https://github.com/GluuFederation/gluu-passport/issues/139)


### Bug Fixes

* **app:** add csrf middleware ([ef71ec4](https://github.com/GluuFederation/gluu-passport/commit/ef71ec434c54a5ce32a3aea87a83558e13bbdfb0)), closes [#140](https://github.com/GluuFederation/gluu-passport/issues/140)
* **app:** generate random secret for session middleware ([c6202ad](https://github.com/GluuFederation/gluu-passport/commit/c6202ad464f2f1b311c965d28b5db49b5078ac49)), closes [#144](https://github.com/GluuFederation/gluu-passport/issues/144)
* **app-factory.js:** add missing parenthesis to randomSecret() ([2ff8a29](https://github.com/GluuFederation/gluu-passport/commit/2ff8a29f35382eedb1560d324f8306fed8effd27))
* **app-factory.js:** fix location undefine and req.flash function problem ([6d10f9b](https://github.com/GluuFederation/gluu-passport/commit/6d10f9ba8be788ef4265c550b82996bfd0872000)), closes [#170](https://github.com/GluuFederation/gluu-passport/issues/170) [#173](https://github.com/GluuFederation/gluu-passport/issues/173)
* **app-factory.js:** remove undeeded csurf middleware ([2b2152f](https://github.com/GluuFederation/gluu-passport/commit/2b2152f6483121dbb46b4dbda022e05de4aeb4e7)), closes [#169](https://github.com/GluuFederation/gluu-passport/issues/169)
* **husky:** add missing .huskyrc.json ([990ce91](https://github.com/GluuFederation/gluu-passport/commit/990ce911bb442c4c9fdfdc5aaec4fc42e1851a45))
* **logging.js:** add propper code for assigning empty string to msg ([9846f23](https://github.com/GluuFederation/gluu-passport/commit/9846f2314592463ceeae23a8b6bf45dc647df6bd))
* **routes.js:** remove metadata input name on outgoing request ([1738306](https://github.com/GluuFederation/gluu-passport/commit/1738306ec44daf5e3e5a0b31852a68149f63071e)), closes [#137](https://github.com/GluuFederation/gluu-passport/issues/137)
* **routes.js:** remove provider name from error message to avoid cross script ([577daaa](https://github.com/GluuFederation/gluu-passport/commit/577daaacefbb10075fbdd2b5753c7e76f90b418c)), closes [#137](https://github.com/GluuFederation/gluu-passport/issues/137)
* **routes.js:** remove received input from error output msg ([4c7f204](https://github.com/GluuFederation/gluu-passport/commit/4c7f2044afbb7a61ada9b17ded9baad80c24ccbe)), closes [#137](https://github.com/GluuFederation/gluu-passport/issues/137)
* **uma.js:** fixed form data send problem ([478b452](https://github.com/GluuFederation/gluu-passport/commit/478b4528ed793f22b87371b985d7a9f448269101)), closes [#205](https://github.com/GluuFederation/gluu-passport/issues/205)

### [4.3.8](https://github.com/GluuFederation/gluu-passport/compare/v4.3.7...v4.3.8) (2020-12-10)


### Bug Fixes

* **app-factory.js:** fix location undefine and req.flash function problem ([6d10f9b](https://github.com/GluuFederation/gluu-passport/commit/6d10f9ba8be788ef4265c550b82996bfd0872000)), closes [#170](https://github.com/GluuFederation/gluu-passport/issues/170) [#173](https://github.com/GluuFederation/gluu-passport/issues/173)
* **app-factory.js:** remove undeeded csurf middleware ([2b2152f](https://github.com/GluuFederation/gluu-passport/commit/2b2152f6483121dbb46b4dbda022e05de4aeb4e7)), closes [#169](https://github.com/GluuFederation/gluu-passport/issues/169)

### [4.3.7](https://github.com/GluuFederation/gluu-passport/compare/v4.3.6...v4.3.7) (2020-11-25)


### Bug Fixes

* **app:** add csrf middleware ([ef71ec4](https://github.com/GluuFederation/gluu-passport/commit/ef71ec434c54a5ce32a3aea87a83558e13bbdfb0)), closes [#140](https://github.com/GluuFederation/gluu-passport/issues/140)
* **app:** generate random secret for session middleware ([c6202ad](https://github.com/GluuFederation/gluu-passport/commit/c6202ad464f2f1b311c965d28b5db49b5078ac49)), closes [#144](https://github.com/GluuFederation/gluu-passport/issues/144)
* **app-factory.js:** add missing parenthesis to randomSecret() ([2ff8a29](https://github.com/GluuFederation/gluu-passport/commit/2ff8a29f35382eedb1560d324f8306fed8effd27))
* **husky:** add missing .huskyrc.json ([990ce91](https://github.com/GluuFederation/gluu-passport/commit/990ce911bb442c4c9fdfdc5aaec4fc42e1851a45))
* **logging.js:** add propper code for assigning empty string to msg ([9846f23](https://github.com/GluuFederation/gluu-passport/commit/9846f2314592463ceeae23a8b6bf45dc647df6bd))
* **routes.js:** remove metadata input name on outgoing request ([1738306](https://github.com/GluuFederation/gluu-passport/commit/1738306ec44daf5e3e5a0b31852a68149f63071e)), closes [#137](https://github.com/GluuFederation/gluu-passport/issues/137)
* **routes.js:** remove provider name from error message to avoid cross script ([577daaa](https://github.com/GluuFederation/gluu-passport/commit/577daaacefbb10075fbdd2b5753c7e76f90b418c)), closes [#137](https://github.com/GluuFederation/gluu-passport/issues/137)
* **routes.js:** remove received input from error output msg ([4c7f204](https://github.com/GluuFederation/gluu-passport/commit/4c7f2044afbb7a61ada9b17ded9baad80c24ccbe)), closes [#137](https://github.com/GluuFederation/gluu-passport/issues/137)

### [4.3.6](https://github.com/GluuFederation/gluu-passport/compare/v4.3.5...v4.3.6) (2020-10-31)

### Bug Fixes

* **routes.js:** add extended option to urlencode function call ([74ae36c](https://github.com/GluuFederation/gluu-passport/commit/74ae36ca692423130bab5adccc7222c7fd8dc2b1)), closes [#126](https://github.com/GluuFederation/gluu-passport/issues/126)
* solved the provider update strategy problem [#119](https://github.com/GluuFederation/gluu-passport/issues/119) ([3c4f725](https://github.com/GluuFederation/gluu-passport/commit/3c4f725003d2bfec1f8677b51b19b6ff01b512a5))
